-- macro:
-- #showtooltip
-- /ShamanMount ground_mount_name,flying_mount_name,shift_mount_name,ctrl_mount_name,alt_mount_name
-- /click ShamanMount

CreateFrame("Button","ShamanMount",nil,"SecureActionButtonTemplate")
ShamanMountData = {["MacroName"]=nil,["GroundMountName"]=nil,["FlyingMountName"]=nil,["ShiftMountName"]=nil,["CtrlMountName"]=nil,["AltMountName"]=nil}
local GhostWolf = GetSpellInfo(2645)
local WaterWalking = GetSpellInfo(546)
local AbyssalSeahorse = GetSpellInfo(75207)
local SubduedSeaHorse = GetSpellInfo(98718)
local SeaTurtle = GetSpellInfo(64731)
local AzureWaterStrider = GetSpellInfo(118089)
local ExpertRiding
local ArtisanRiding
local MasterRiding
local FlightMastersLicense
local ColdWeatherFlying
local WisdomoftheFourWinds
local UsableSpellWaterBugFixNotNeeded
local WaterWalkingMacro = "/cast [@player]"..WaterWalking.."\n"
local time=GetTime()
local _,Class=UnitClass("player")
local IsVashjir
local AbyssalOk
local SeaHorseOk
local SeaTurtleOk


-- ** EXPLANATION of function IsUsableSpellWaterBugFix() **
-- IsUsableSpell("flying_mount_name") returns false if your char don't have the flying skill/license required to fly
-- however if you are standing on a water body (even if very shallow) IsUsableSpell("flying_mount_name") returns true (it shouldn't).
-- To deal with this bug an additional check to see if your char has the proper flying skill/license is needed.
-- if in Azeroth, Kalimdor, Eastern Kingdoms or The Maelstrom (continents 0, 1, 2 or 5) check for Flight Master's License (which implies at least Expert Riding)
-- if in Outland (continent 3) check for Expert Riding, Artisan Riding or Master Riding (Artisan replaces Expert and Master replaces Artisan)
-- if in Northrend (continent 4) check for Cold Weather Flying (which implies at least Expert Riding)
-- if in Pandaria (continent 6) check for Wisdom of the Four Winds (which implies at least Expert Riding)
-- if the char has all licenses (which implies at least Expert Riding) the bug can't cause any effect anywhere
-- so a variable called UsableSpellWaterBugFixNotNeeded is set once on PLAYER_LOGIN (flying skill/licenses available)
-- to make the function run faster (no need to check continent and flying skill/licenses)

local function IsUsableSpellWaterBugFix()
  if UsableSpellWaterBugFixNotNeeded then
    return true
  end

  local Continent

  SetMapToCurrentZone()
  Continent = GetCurrentMapContinent()
  if (Continent==0 or Continent==1 or Continent==2 or Continent==5) and FlightMastersLicense then
    return true
  elseif Continent==3 and (ExpertRiding or ArtisanRiding or MasterRiding) then
    return true
  elseif Continent==4 and ColdWeatherFlying then
    return true
  elseif Continent==6 and WisdomoftheFourWinds then
    return true
  end  
  return false
end

SLASH_SHAMANMOUNT1 = "/ShamanMount"
SlashCmdList["SHAMANMOUNT"] = function(msg)
GMN = msg:match("[^,]*")
if GMN then
	GMN = GMN:gsub("%s*$","")
end
FMN = msg:match(",%s*([^,]*)")
if FMN then
	FMN = FMN:gsub("%s*$","")
end
SMN = msg:match(",[^,]*,%s*([^,]*)")
if SMN then
	SMN = SMN:gsub("%s*$","")
end
CMN = msg:match(",[^,]*,[^,]*,%s*([^,]*)%s*")
if CMN then
	CMN = CMN:gsub("%s*$","")
end
AMN = msg:match(",[^,]*,[^,]*,[^,]*,%s*([^,]*)")
if AMN then
	AMN = AMN:gsub("%s*$","")
end

  local InstanceType 
  local IsMoving = GetUnitSpeed("player")~=0
  local AzureOk = IsUsableSpell(AzureWaterStrider)
  local JustSubmerged = IsSubmerged() and GetTime()-time<1.0
  local FlyingOk = IsUsableSpell(FMN) and IsUsableSpellWaterBugFix()
  local GroundOk = IsUsableSpell(GMN)
  local ShiftOk = IsUsableSpell(SMN)
  local CtrlOk = IsUsableSpell(CMN)
  local AltOk = IsUsableSpell(AMN)
  local nobg

  IsVashjir = strsub(GetMapInfo()~=nil and GetMapInfo() or "",0,7)=="Vashjir"
  AbyssalOk = IsUsableSpell(AbyssalSeahorse)
  SeaHorseOk = IsUsableSpell(SubduedSeaHorse)
  SeaTurtleOk = IsUsableSpell(SeaTurtle)
  _,InstanceType=IsInInstance()
  nobg = IsInInstance()~="pvp"

  ShamanMountData["MacroName"]=GetMacroInfo(GetRunningMacro())
  ShamanMountData["GroundMountName"]=GMN
  ShamanMountData["FlyingMountName"]=FMN~=nil and FMN or GMN
  ShamanMountData["ShiftMountName"]=SMN
  ShamanMountData["CtrlMountName"]=CMN
  ShamanMountData["AltMountName"]=AMN

  if not InCombatLockdown() then
    ShamanMount:SetAttribute("type","macro")
    if CanExitVehicle() then
      ShamanMount:SetAttribute("macrotext","/run VehicleExit()")
    elseif IsMounted() then
      ShamanMount:SetAttribute("macrotext","/dismount [noflying]")
    elseif IsShiftKeyDown() and ShiftOk then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..SMN)
    elseif IsControlKeyDown() and CtrlOk then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..CMN)
    elseif IsAltKeyDown() and AltOk then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..AMN)
    elseif IsMoving then
      ShamanMount:SetAttribute("macrotext","/cast "..GhostWolf)
    elseif JustSubmerged and FlyingOk then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..FMN)
    elseif JustSubmerged and AzureOk and nobg and Class~="SHAMAN" then
      ShamanMount:SetAttribute("macrotext","/cast "..AzureWaterStrider)
    elseif IsVashjir and AbyssalOk then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..AbyssalSeahorse)
    elseif SeaTurtleOk and IsSubmerged() then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..SeaTurtle)
    elseif SeaHorseOk then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..SubduedSeahorse)
    elseif FlyingOk and IsSubmerged() then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..FMN)
    elseif FlyingOk then
      ShamanMount:SetAttribute("macrotext","/cast "..FMN)
    elseif GroundOk then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..GMN)
    else
      ShamanMount:SetAttribute("macrotext","/cast "..GhostWolf)
    end
  end
end

ShamanMount:SetScript("OnEvent",function(self,event)
  IsVashjir = strsub(GetMapInfo()~=nil and GetMapInfo() or "",0,7)=="Vashjir"
  AbyssalOk = IsUsableSpell(AbyssalSeahorse)
  SeaHorseOk = IsUsableSpell(SubduedSeaHorse)
  SeaTurtleOk = IsUsableSpell(SeaTurtle)
  if event=="PLAYER_LOGIN" then
    ExpertRiding = IsSpellKnown(34090)
    ArtisanRiding = IsSpellKnown(34091)
    MasterRiding = IsSpellKnown(90265)
    FlightMastersLicense = IsSpellKnown(90267)
    ColdWeatherFlying = IsSpellKnown(54197)
    WisdomoftheFourWinds = IsSpellKnown(115913)
    UsableSpellWaterBugFixNotNeeded = FlightMastersLicense and ColdWeatherFlying and WisdomoftheFourWinds
  end
  if event=="PLAYER_REGEN_DISABLED" then
    ShamanMount:UnregisterEvent("SPELL_UPDATE_USABLE")
    ShamanMount:UnregisterEvent("MODIFIER_STATE_CHANGED")
    ShamanMount:SetAttribute("type","macro")
    ShamanMount:SetAttribute("macrotext","/run if CanExitVehicle() then VehicleExit() end\n/cast [nomounted]"..GhostWolf.."\n/dismount [noflying]")
  end
  if event=="PLAYER_REGEN_ENABLED" then
    ShamanMount:RegisterEvent("SPELL_UPDATE_USABLE")
    ShamanMount:RegisterEvent("MODIFIER_STATE_CHANGED")
  end
  if event=="SPELL_UPDATE_USABLE" and not IsSubmerged() then
    time=GetTime()
  end
  if IsShiftKeyDown() and IsUsableSpell(ShamanMountData["ShiftMountName"]) then
    SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["ShiftMountName"])
  elseif IsControlKeyDown() and IsUsableSpell(ShamanMountData["CtrlMountName"]) then
    SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["CtrlMountName"])
  elseif IsAltKeyDown() and IsUsableSpell(ShamanMountData["AltMountName"]) then
    SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["AltMountName"])
  elseif IsVashjir and IsSubmerged() and (AbyssalOk or Class~="SHAMAN" and GetSpellInfo(AbyssalSeahorse)) then
    SetMacroSpell(ShamanMountData["MacroName"],AbyssalSeahorse)
  elseif IsSubmerged() and (SeaHorseOk or Class~="SHAMAN" and GetSpellInfo(SubduedSeahorse)) then
    SetMacroSpell(ShamanMountData["MacroName"],SubduedSeahorse)
  elseif IsSubmerged() and (SeaTurtleOk or Class~="SHAMAN" and GetSpellInfo(SeaTurtle)) then
    SetMacroSpell(ShamanMountData["MacroName"],SeaTurtle)
  elseif IsUsableSpell(ShamanMountData["FlyingMountName"]) and IsUsableSpellWaterBugFix() or Class~="SHAMAN" and IsFlyableArea() and GetSpellInfo(ShamanMountData["FlyingMountName"]) then
    SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["FlyingMountName"])
  elseif IsUsableSpell(ShamanMountData["GroundMountName"]) or Class~="SHAMAN" and GetSpellInfo(ShamanMountData["GroundMountName"]) then
    SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["GroundMountName"])
  elseif Class=="SHAMAN" then
    SetMacroSpell(ShamanMountData["MacroName"],GhostWolf)
  end
end)

ShamanMount:RegisterEvent("PLAYER_LOGIN")
ShamanMount:RegisterEvent("PLAYER_REGEN_ENABLED")
ShamanMount:RegisterEvent("PLAYER_REGEN_DISABLED")
ShamanMount:RegisterEvent("SPELL_UPDATE_USABLE")
ShamanMount:RegisterEvent("UPDATE_MACROS")
ShamanMount:RegisterEvent("MODIFIER_STATE_CHANGED")